curl --request GET \
--url https://api.withterminal.com/tsp/v1/vehicles/{vehicleId}/stats/historical \
--header 'Authorization: Bearer <token>' \
--header 'Connection-Token: <connection-token>'import requests
url = "https://api.withterminal.com/tsp/v1/vehicles/{vehicleId}/stats/historical"
headers = {
"Connection-Token": "<connection-token>",
"Authorization": "Bearer <token>"
}
response = requests.get(url, headers=headers)
print(response.text)const options = {
method: 'GET',
headers: {'Connection-Token': '<connection-token>', Authorization: 'Bearer <token>'}
};
fetch('https://api.withterminal.com/tsp/v1/vehicles/{vehicleId}/stats/historical', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"results": [
[
{
"id": "vcl_st_01D8ZQFGHVJ858NBF2Q7DV9MNC",
"sourceId": "123456789",
"provider": "geotab",
"type": "engine_state",
"timestamp": "2021-01-06T03:24:53.000Z",
"vehicle": "vcl_01D8ZQFGHVJ858NBF2Q7DV9MNC",
"state": "on",
"metadata": {
"modifiedAt": "2021-01-06T03:24:53.000Z"
},
"raw": []
},
{
"id": "vcl_st_01D8ZQFGHVJ8584BF2Q7D29M2D",
"sourceId": "987654321",
"provider": "geotab",
"type": "odometer",
"timestamp": "2021-01-06T04:34:52.000Z",
"vehicle": "vcl_01D8ZQFGHVJ858NBF2Q7DV9MNC",
"odometer": 230843,
"raw": []
},
{
"id": "vcl_st_01D8ZQFGHVJ8584BF2Q7D29M3E",
"sourceId": "987654322",
"provider": "geotab",
"type": "engine_runtime",
"timestamp": "2021-01-06T04:34:52.000Z",
"vehicle": "vcl_01D8ZQFGHVJ858NBF2Q7DV9MNC",
"duration": 1234.5,
"raw": []
},
{
"id": "vcl_st_01D8ZQFGHVJ8584BF2Q7D29M3F",
"sourceId": "987654323",
"provider": "geotab",
"type": "engine_oil_percentage",
"timestamp": "2021-01-06T04:34:52.000Z",
"vehicle": "vcl_01D8ZQFGHVJ858NBF2Q7DV9MNC",
"percentage": 85,
"raw": []
},
{
"id": "vcl_st_01D8ZQFGHVJ8584BF2Q7D29M3G",
"sourceId": "987654324",
"provider": "geotab",
"type": "engine_oil_pressure",
"timestamp": "2021-01-06T04:34:52.000Z",
"vehicle": "vcl_01D8ZQFGHVJ858NBF2Q7DV9MNC",
"pressure": 45.2,
"raw": []
},
{
"id": "vcl_st_01D8ZQFGHVJ8584BF2Q7D29M3H",
"sourceId": "987654325",
"provider": "geotab",
"type": "engine_oil_temperature",
"timestamp": "2021-01-06T04:34:52.000Z",
"vehicle": "vcl_01D8ZQFGHVJ858NBF2Q7DV9MNC",
"temperature": 95,
"raw": []
},
{
"id": "vcl_st_01D8ZQFGHVJ8584BF2Q7D29M3I",
"sourceId": "987654326",
"provider": "geotab",
"type": "engine_coolant_temperature",
"timestamp": "2021-01-06T04:34:52.000Z",
"vehicle": "vcl_01D8ZQFGHVJ858NBF2Q7DV9MNC",
"temperature": 90,
"raw": []
},
{
"id": "vcl_st_01D8ZQFGHVJ8584BF2Q7D29M3J",
"sourceId": "987654327",
"provider": "geotab",
"type": "coolant_percentage",
"timestamp": "2021-01-06T04:34:52.000Z",
"vehicle": "vcl_01D8ZQFGHVJ858NBF2Q7DV9MNC",
"percentage": 75,
"raw": []
},
{
"id": "vcl_st_01D8ZQFGHVJ8584BF2Q7D29M3K",
"sourceId": "987654328",
"provider": "geotab",
"type": "engine_rpm",
"timestamp": "2021-01-06T04:34:52.000Z",
"vehicle": "vcl_01D8ZQFGHVJ858NBF2Q7DV9MNC",
"rpm": 2500,
"raw": []
},
{
"id": "vcl_st_01D8ZQFGHVJ8584BF2Q7D29M3L",
"sourceId": "987654329",
"provider": "geotab",
"type": "battery_voltage",
"timestamp": "2021-01-06T04:34:52.000Z",
"vehicle": "vcl_01D8ZQFGHVJ858NBF2Q7DV9MNC",
"voltage": 12.5,
"raw": []
}
]
],
"next": "cD0yMDIxLTAxLTA2KzAzJTNBMjQlM0E1My40MzQzMjYlMkIwMCUzQTAw"
}{
"code": "bad_request",
"message": "Invalid request body",
"detail": [
{
"message": "'vehicleId' property must be a valid ulid",
"path": "{requestQuery}.vehicleId",
"suggestion": "Please ensure you submit a valid 'vehicleId' property",
"context": {}
}
]
}{
"code": "unauthorized",
"message": "Unauthorized Request",
"detail": "Please ensure you have a valid API key"
}{
"code": "forbidden",
"message": "Forbidden Request",
"detail": "Please ensure the connection token matches the resource you are attempting to access."
}{
"code": "not_found",
"message": "Resource not found",
"detail": "Could not find resource with ID: 2342342"
}{
"code": "too_many_requests",
"message": "Too Many Requests",
"retryAfter": 60,
"detail": "You have exceeded your rate limit. Please try again later."
}{
"code": "internal_server_error",
"message": "Internal Server Error",
"detail": "Something went wrong"
}{
"code": "gateway_timeout",
"message": "Gateway Timeout"
}Historical Vehicle Stats
List historical stats and logs about the vehicle.
Authorizations
Bearer authentication header of the form Bearer <token>, where <token> is your auth token.
Headers
Scopes the request to a Terminal application in the caller's organization. Required for multi-application organizations when using a user session or OAuth access token. API keys are already bound to a single application.
The token returned when a user authenticated their account. This authorizes access to a specific account.
^con_tkn_\S+$"con_tkn_22vUhkC6tgre4kwaYfUkCDA1rzn6eyb4"
Path Parameters
Unique identifier for the vehicle in Terminal.
^vcl_[0-9A-HJKMNP-TV-Z]{26}$"vcl_01D8ZQFGHVJ858NBF2Q7DV9MNC"
Query Parameters
Pagination cursor to start requests from
"cD0yMDIxLTAxLTA2KzAzJTNBMjQlM0E1My40MzQzMjYlMkIwMCUzQTAw"
The maximum number of results to return in a page.
Expand resources in the returned response
vehicle Timestamp to start from - defaults to beginning of history
"2021-01-06T03:24:53.000Z"
Timestamp to end at - defaults to now
"2021-01-06T03:24:53.000Z"
Comma separated list of vehicle stats to filter for
"odometer,engine_state,fuel_level,total_fuel_consumption"
Include raw responses used to normalize model. Used for debugging or accessing unique properties that are not unified.
Response
OK
- Engine State Log
- Odometer Log
- Total Fuel Consumption Log
- Fuel Level Log
- Engine Runtime Log
- Engine Oil Percentage Log
- Engine Oil Pressure Log
- Engine Oil Temperature Log
- Engine Coolant Temperature Log
- Coolant Percentage Log
- Engine RPM Log
- Battery Voltage Log
Show child attributes
Show child attributes
[
{
"id": "vcl_st_01D8ZQFGHVJ858NBF2Q7DV9MNC",
"sourceId": "123456789",
"provider": "geotab",
"type": "engine_state",
"timestamp": "2021-01-06T03:24:53.000Z",
"vehicle": "vcl_01D8ZQFGHVJ858NBF2Q7DV9MNC",
"state": "on",
"metadata": { "modifiedAt": "2021-01-06T03:24:53.000Z" },
"raw": []
},
{
"id": "vcl_st_01D8ZQFGHVJ8584BF2Q7D29M2D",
"sourceId": "987654321",
"provider": "geotab",
"type": "odometer",
"timestamp": "2021-01-06T04:34:52.000Z",
"vehicle": "vcl_01D8ZQFGHVJ858NBF2Q7DV9MNC",
"odometer": 230843,
"raw": []
},
{
"id": "vcl_st_01D8ZQFGHVJ8584BF2Q7D29M3E",
"sourceId": "987654322",
"provider": "geotab",
"type": "engine_runtime",
"timestamp": "2021-01-06T04:34:52.000Z",
"vehicle": "vcl_01D8ZQFGHVJ858NBF2Q7DV9MNC",
"duration": 1234.5,
"raw": []
},
{
"id": "vcl_st_01D8ZQFGHVJ8584BF2Q7D29M3F",
"sourceId": "987654323",
"provider": "geotab",
"type": "engine_oil_percentage",
"timestamp": "2021-01-06T04:34:52.000Z",
"vehicle": "vcl_01D8ZQFGHVJ858NBF2Q7DV9MNC",
"percentage": 85,
"raw": []
},
{
"id": "vcl_st_01D8ZQFGHVJ8584BF2Q7D29M3G",
"sourceId": "987654324",
"provider": "geotab",
"type": "engine_oil_pressure",
"timestamp": "2021-01-06T04:34:52.000Z",
"vehicle": "vcl_01D8ZQFGHVJ858NBF2Q7DV9MNC",
"pressure": 45.2,
"raw": []
},
{
"id": "vcl_st_01D8ZQFGHVJ8584BF2Q7D29M3H",
"sourceId": "987654325",
"provider": "geotab",
"type": "engine_oil_temperature",
"timestamp": "2021-01-06T04:34:52.000Z",
"vehicle": "vcl_01D8ZQFGHVJ858NBF2Q7DV9MNC",
"temperature": 95,
"raw": []
},
{
"id": "vcl_st_01D8ZQFGHVJ8584BF2Q7D29M3I",
"sourceId": "987654326",
"provider": "geotab",
"type": "engine_coolant_temperature",
"timestamp": "2021-01-06T04:34:52.000Z",
"vehicle": "vcl_01D8ZQFGHVJ858NBF2Q7DV9MNC",
"temperature": 90,
"raw": []
},
{
"id": "vcl_st_01D8ZQFGHVJ8584BF2Q7D29M3J",
"sourceId": "987654327",
"provider": "geotab",
"type": "coolant_percentage",
"timestamp": "2021-01-06T04:34:52.000Z",
"vehicle": "vcl_01D8ZQFGHVJ858NBF2Q7DV9MNC",
"percentage": 75,
"raw": []
},
{
"id": "vcl_st_01D8ZQFGHVJ8584BF2Q7D29M3K",
"sourceId": "987654328",
"provider": "geotab",
"type": "engine_rpm",
"timestamp": "2021-01-06T04:34:52.000Z",
"vehicle": "vcl_01D8ZQFGHVJ858NBF2Q7DV9MNC",
"rpm": 2500,
"raw": []
},
{
"id": "vcl_st_01D8ZQFGHVJ8584BF2Q7D29M3L",
"sourceId": "987654329",
"provider": "geotab",
"type": "battery_voltage",
"timestamp": "2021-01-06T04:34:52.000Z",
"vehicle": "vcl_01D8ZQFGHVJ858NBF2Q7DV9MNC",
"voltage": 12.5,
"raw": []
}
]
Cursor used for pagination.
"cD0yMDIxLTAxLTA2KzAzJTNBMjQlM0E1My40MzQzMjYlMkIwMCUzQTAw"